Attribute VB_Name = "modGeneral"
Option Explicit

Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40

Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Private Const WM_SYSCOMMAND = &H112

Public Declare Function GetMenuItemCount Lib "user32" (ByVal hmenu As Long) As Long
Public Declare Function GetMenuItemID Lib "user32" (ByVal hmenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hmenu As Long, ByVal wIDItem As Long, ByVal lpstring As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Public Declare Function GetSubMenu Lib "user32" (ByVal hmenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long

Private Declare Function SendMessageByNum Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wparam As Long, lparam As Long) As Long

Public Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
 dwOSVersionInfoSize As Long
 dwMajorVersion As Long
 dwMinorVersion As Long
 dwBuildNumber As Long
 dwPlatformId As Long
 szCSDVersion As String * 128
End Type

Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Long

Private Type KeyboardBytes
 kbByte(0 To 255) As Byte
End Type

Public Sample As Long, LastStr As String, kbOld As KeyboardBytes

Public Sub SetForeground(hwnd As Long, Top As Boolean)
'.------------------------------------------------------------------------------
'.  Funktion :  Setzt ein Fenster fr immer in den Vordergrund bzw. setzt diesen
'.              Zustand wieder zurck.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: hwnd - Fensterhandel
'.             Top  - True  : Fenster immer in den Vordergrund
'.             Top  - False : Fenster zeigt wieder normales Verhalten
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 If Top = True Then
   SetWindowPos hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
  Else
   SetWindowPos hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
 End If
End Sub

Public Function InStrRevVB5(String1 As String, String2 As String, Optional MatchCase As Boolean = False, Optional ReverseCount As Boolean = False) As Long
'.------------------------------------------------------------------------------
'.  Funktion : Gibt die Position eines Vorkommnisses einer Zeichenfolge in einer
'.             anderen Zeichenfolge vom Ende der Zeichenfolge gesehen an.
'.             Eine hnliche Funtion existiert in VB6.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: String1      - Der zu durchsuchende String.
'.             String2      - String, nach dem gesucht wird.
'.             Matchcase    - True  : Gro/Kleinschreibung wird beachtet
'.                            False : Gro/Kleinschreibung wird nicht beachtet. (Standard)
'.             ReverseCount - True  : Positition vom Ende des Strings wiedergeben.
'.                            False : Positition vom Ende des Strings wiedergeben. (Standard)
'.
'.
'.  Rckgabe : Position der gesuchten Zeichenfolge.
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim i As Long, Lastfound As Long
 If MatchCase = False Then
  String1 = UCase(String1)
  String2 = UCase(String2)
 End If

 For i = 1 To Len(String1)
  If Mid(String1, i, Len(String2)) = String2 Then
   Lastfound = i
  End If
 Next i

 If ReverseCount And Lastfound > 0 Then
   InStrRevVB5 = Len(String1) - Lastfound + 1
  Else
   InStrRevVB5 = Lastfound
 End If
End Function

Public Function ReplaceVB5(ByVal ExpressionStr As String, FindStr As String, ReplaceStr As String) As String
'.------------------------------------------------------------------------------
'.  Funktion :  Ersetzt einen Teilstring innerhalbe eines vorgegebenen Strings
'.              mit einem anderen String.
'.              Diese Funktion ist standardmig nicht in VB5 enthalten.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: ExpressionStr - Der String, der durchsucht wird.
'.             FindStr       - Der String, der gefunden werden soll.
'.             ReplaceStr    - Der gefundene String wird durch diesen String ersetzt.
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim i As Long, tStr As String
 i = 1: tStr = ""
 Do
  i = InStr(1, ExpressionStr, FindStr, 0)
  If i > 0 Then
    tStr = tStr + Left$(ExpressionStr, i - 1) & ReplaceStr
    ExpressionStr = Right$(ExpressionStr, Len(ExpressionStr) - i - Len(FindStr) + 1)
   Else
    tStr = tStr + ExpressionStr
  End If
  DoEvents
 Loop Until i = 0
 ReplaceVB5 = tStr
End Function

Public Sub SysMenuClick(ByVal hwnd As Long, ByVal menID As Long)
'.------------------------------------------------------------------------------
'.  Funktion :  Fhrt einen Aufruf eines Systemmen-Eintrages eines fensters durch.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: hwnd  - Fensterhandel
'.             menID - Handel des Systemmen-Eintrages
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 SendMessageByNum hwnd, WM_SYSCOMMAND, menID, 0
End Sub

Public Function GetSystempath() As String
'.------------------------------------------------------------------------------
'.  Funktion :  Ermiitelt den Windows-Systempfad
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : Pfad zum Windows Systemverzeichnis.
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim tStr As String, res As Long
 tStr = Space(255)
 res = GetSystemDirectory(tStr, 255)
 tStr = Trim$(Left$(tStr, res))
 If Right$(tStr, 1) <> "\" Then
  tStr = tStr & "\"
 End If
 GetSystempath = tStr
End Function

Public Function GetWindowspath() As String
'.------------------------------------------------------------------------------
'.  Funktion :  Ermitelt den Windows-Pfad.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : Pfad zum Windows Verzeichnis.
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim tStr As String, res As Long
 tStr = Space(255)
 res = GetWindowsDirectory(tStr, 255)
 tStr = Trim$(Left$(tStr, res))
 If Right$(tStr, 1) <> "\" Then
  tStr = tStr & "\"
 End If
 GetWindowspath = tStr
End Function

Public Function IsWinNT() As Boolean
'.------------------------------------------------------------------------------
'.  Funktion :  Prft ob das Betriebssystem en Windows NT Betriebssystem ist.
'.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : True  - Windows NT 4, Windows 2000, Windows XP, Windows 2003
'.             False - Windows 9x, Windows Me
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim OSInfo As OSVERSIONINFO, res As Long
 OSInfo.dwOSVersionInfoSize = Len(OSInfo)
 res = GetVersionEx(OSInfo)
 If res = 0 Then
   MsgBox "Die Betriebssystem-Version Information konnte nicht ermittelt werden!" & vbCrLf & _
    "Es knnen Fehler auftreten!", vbCritical
   IsWinNT = True
  Else
   If OSInfo.dwPlatformId = 0 Or OSInfo.dwPlatformId = 1 Then
     IsWinNT = False
    Else
     IsWinNT = True
   End If
 End If
End Function

Public Sub CheckKeybordState()
'.------------------------------------------------------------------------------
'.  Funktion : berprft den Status der virtuellen Tasten
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: -
'.
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim aw As Long
 
 If GetKeyState(vbKeyCapital) = 1 Then
  Do
   aw = MsgBox("Bitte schalten Sie die 'CapsLock' Taste aus!" & vbCrLf & _
    "Wenn Sie abbrechen whlen, wird das Programm beendet.", vbOKCancel Or vbExclamation)
   DoEvents
  Loop Until GetKeyState(vbKeyCapital) = 0 Or aw = vbCancel
  If aw = vbCancel Then
   MsgBox "Das Programm wird beendet!", vbExclamation
   End
  End If
 End If
 If GetKeyState(vbKeyScrollLock) = 1 Then
  Do
   aw = MsgBox("Bitte schalten Sie die 'ScrollLock' Taste aus!" & vbCrLf & _
    "Wenn Sie abbrechen whlen, wird das Programm beendet.", vbOKCancel Or vbExclamation)
   DoEvents
  Loop Until GetKeyState(vbKeyScrollLock) = 0 Or aw = vbCancel
  If aw = vbCancel Then
   MsgBox "Das Programm wird beendet!", vbExclamation
   End
  End If
 End If
End Sub
